#
# Table structure for table `allarchives`
#


CREATE database archiver;

use archiver;

grant all on archiver.* to storiq@localhost identified by 'spider77';

use archiver;

CREATE TABLE allarchives (
  ARCHID bigint(20) unsigned NOT NULL default '0',
  TAPEID bigint(20) unsigned NOT NULL default '0',
  POSONTP tinyint(4) NOT NULL default '0',
  CREATOR text NOT NULL,
  ARDTTIME datetime NOT NULL default '0000-00-00 00:00:00',
  ARENDDTTIME datetime NOT NULL default '0000-00-00 00:00:00',
  ARCHSET text NOT NULL,
  ARCHNAME text NOT NULL,
  DESCR text NOT NULL,
  ARSIZEK int(11) NOT NULL default '0',
  WHAT text NOT NULL,
  UNIQUE KEY ARCHID (ARCHID)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `alldrives`
#

CREATE TABLE alldrives (
  DRIVEID tinyint(4) NOT NULL default '0',
  DRNAME tinytext NOT NULL,
  DRTYPE tinytext NOT NULL,
  TPFORMAT tinytext NOT NULL,
  DRDEV tinytext NOT NULL,
  DRSCDEV tinytext NOT NULL,
  CHGRDEV tinytext NOT NULL,
  TPDRVENDOR tinytext NOT NULL,
  TPDRMODEL tinytext NOT NULL,
  CHGRVENDOR tinytext NOT NULL,
  CHGRMODEL tinytext NOT NULL,
  DRPOSONTP int(11) NOT NULL default '-1',
  DRSPEEDK int(11) NOT NULL default '0',
  DRCYCLE int(11) NOT NULL default '0',
  DRBLKSIZEK int(11) NOT NULL default '10',
  DRPROCESS tinyint(4) NOT NULL default '0',
  UNIQUE KEY DRIVEID (DRIVEID)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `allfiles`
#

CREATE TABLE allfiles (
  FIDX bigint(20) unsigned NOT NULL auto_increment,
  FILENAME text NOT NULL,
  FILEPATH text NOT NULL,
  FILESIZE int(11) NOT NULL default '0',
  FILEOWNER tinytext NOT NULL,
  FILEDATE datetime NOT NULL default '0000-00-00 00:00:00',
  RECDATETIME datetime NOT NULL default '0000-00-00 00:00:00',
  TAPEID bigint(20) unsigned NOT NULL default '0',
  ARCHID bigint(20) unsigned NOT NULL default '0',
  MD5SUM tinytext NOT NULL,
  UNIQUE KEY FIDX (FIDX),
  KEY FILEVER (FILENAME(128),FILEPATH(255),FILEDATE),
  KEY SAMEFILE (FILENAME(128),MD5SUM(128))
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `alljobs`
#

CREATE TABLE alljobs (
  JOBID int(11) NOT NULL auto_increment,
  PRIORITY tinyint(4) NOT NULL default '0',
  JOBTYPE enum('RESTORE','SAVE','DIFFSAVE','VERIFY','COMPARE','LIST','PURGE','TEST') NOT NULL default 'SAVE',
  FROMDIR text NOT NULL,
  CMDOPT text NOT NULL,
  WHAT text NOT NULL,
  TAPEID bigint(20) unsigned NOT NULL default '0',
  DRIVEID int(11) NOT NULL default '0',
  REPORTTO text NOT NULL,
  STATUS enum('TODO','RUNNING','DONE','DELAYED','ERROR') NOT NULL default 'TODO',
  MESSAGE text NOT NULL,
  ISARCHIVE enum('Y','N') NOT NULL default 'N',
  CREATOR tinytext NOT NULL,
  ARCHID bigint(20) unsigned NOT NULL default '0',
  ARCHNAME text NOT NULL,
  DESCR text NOT NULL,
  JSTTIME datetime NOT NULL default '0000-00-00 00:00:00',
  JENDTIME datetime NOT NULL default '0000-00-00 00:00:00',
  UNIQUE KEY JOBID (JOBID),
  KEY DRJOB (JOBID,DRIVEID),
  KEY PRIORITY (PRIORITY)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `allslots`
#

CREATE TABLE allslots (
  DRIVEID tinyint(4) NOT NULL default '0',
  SLOTNUM int(11) NOT NULL default '0',
  SLOTTYPE enum('DRIVE','SLOT','INOUT') NOT NULL default 'SLOT',
  TAPEIN enum('Y','N') NOT NULL default 'N',
  TAPEID bigint(20) unsigned NOT NULL default '0',
  TPLABEL text NOT NULL,
  XCHANGE enum('Y','N') NOT NULL default 'N',
  STATUS enum('UNKNOWN','UNUSED','INUSE','FULL','ERROR') NOT NULL default 'UNKNOWN',
  FROMSLOT tinyint(4) NOT NULL default '0',
  UNIQUE KEY SLOTINDEX (DRIVEID,SLOTNUM)
) TYPE=MyISAM COMMENT='xchange : slot that can be extracted';
# --------------------------------------------------------

#
# Table structure for table `alltapes`
#

CREATE TABLE alltapes (
  TAPEID bigint(20) unsigned NOT NULL default '0',
  TPLABEL text NOT NULL,
  TPNAME text NOT NULL,
  TPDATETIME datetime NOT NULL default '0000-00-00 00:00:00',
  TPTYPE enum('ARCHIVE','BACKUP') NOT NULL default 'ARCHIVE',
  EXPIRES datetime NOT NULL default '0000-00-00 00:00:00',
  NOACCESS char(1) NOT NULL default 'N',
  TPSPACE int(11) NOT NULL default '0',
  TPFORMAT tinytext NOT NULL,
  UNIQUE KEY TAPEID (TAPEID)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `storiqusers`
#

CREATE TABLE storiqusers (
  KSLOGIN varchar(60) NOT NULL default '',
  KSPASSWD varchar(60) NOT NULL default '',
  KSHOMEDIR tinytext NOT NULL,
  KSFULLNM tinytext NOT NULL,
  KSEMAIL tinytext NOT NULL,
  KS_SAVE enum('Y','N') NOT NULL default 'Y',
  KS_BACKUP enum('Y','N') NOT NULL default 'N',
  KS_REST enum('Y','N') NOT NULL default 'Y',
  KS_LIST enum('Y','N') NOT NULL default 'Y',
  KS_ADMIN enum('Y','N') NOT NULL default 'N',
  KS_JOBED enum('Y','N') NOT NULL default 'N',
  UNIQUE KEY KSLOGIN (KSLOGIN)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `progjobs`
#

CREATE TABLE progjobs (
  PJOBID int(11) NOT NULL auto_increment,
  JOBTYPE enum('RESTORE','SAVE','DIFFSAVE','INCSAVE','VERIFY','COMPARE','LIST','TEST') NOT NULL default 'SAVE',
  FROMDIR text NOT NULL,
  CMDOPT text NOT NULL,
  WHAT text NOT NULL,
  TAPEID bigint(20) unsigned NOT NULL default '0',
  DRIVEID int(11) NOT NULL default '0',
  REPORTTO text NOT NULL,
  STATUS enum('TODO','DONE','MISSED','ERROR') NOT NULL default 'TODO',
  MESSAGE text NOT NULL,
  ISARCHIVE enum('Y','N') NOT NULL default 'N',
  CREATOR tinytext NOT NULL,
  ARCHID bigint(20) unsigned NOT NULL default '0',
  ARCHNAME text NOT NULL,
  DESCR text NOT NULL,
  JSTTIME datetime NOT NULL default '0000-00-00 00:00:00',
  JENDTIME datetime NOT NULL default '2100-12-31 00:00:00',
  REPEATMODE enum('None','Day','Week','Month') NOT NULL default 'None',
  REPEATCOUNT int(11) NOT NULL default '-1',
  GENJOB text NOT NULL,
  UNIQUE KEY PJOBID (PJOBID),
  KEY DRPJOB (PJOBID,DRIVEID)
) TYPE=MyISAM;
# --------------------------------------------------------

 insert into storiqusers (kslogin, kspasswd, ks_admin) values ('storiq', password('spider77'), 'Y' );
 
